#!/bin/sh

a= . install2-init-functions

CMDLINE="$(grep -ow 'console=ttyS[^ ]*' /proc/cmdline | head -1)"
[ -n "$CMDLINE" ] || exit 0
UNIT="${CMDLINE#console=ttyS}"
UNIT="${UNIT%%,*}"	# 0
MODE="${CMDLINE#*,}"	# 115200n8
SPEED="${MODE%%n*}"	# 115200

# init; note that installer runs in *unknown* runlevel (not reaching 7)
INITCFG="$destdir/etc/inittab"
if [ -f "$INITCFG" ]; then
	echo "ttyS$UNIT" >> $destdir/etc/securetty
	echo "T0:2345:respawn:/sbin/agetty -L ttyS$UNIT $SPEED vt100" \
		>> "$INITCFG"
fi

# bootloader
GRUBCFG="$destdir/etc/sysconfig/grub2"
if [ -f "$GRUBCFG" ]; then
	sed -i "/^GRUB_CMDLINE_LINUX/s/ quiet / /g;s/ quiet'/'/" "$GRUBCFG"
	cat >> "$GRUBCFG" <<-EOF
	GRUB_TERMINAL_OUTPUT="serial console"
	GRUB_TERMINAL_INPUT="serial console"
	GRUB_SERIAL_COMMAND="serial --unit=$UNIT --speed=$SPEED"
	GRUB_TIMEOUT=10
	EOF
	chroot $destdir update-grub
fi

if [ `arch` = e2k ]; then
	# wasn't even working properly, and e2k fw has 115200 by default
	# NB: needs to be run *after* systemd got installed (_if any_)
	#     so this doesn't make a stage3's %post scriptlet
	SDCFG="$destdir/lib/systemd/system/serial-getty@.service"
	if [ -f "$SDCFG" ]; then
		sed -i "s/--keep-baud 115200,38400,9600/115200/" "$SDCFG"
	fi

	# BMC-wired ttyS1 is pretty much required on 1E16C-uATX, for example
	if [ -c /dev/ttyS1 ]; then
		echo "ttyS1" >> $destdir/etc/securetty
		echo "T1:2345:respawn:/sbin/agetty -L ttyS1 115200 vt100" \
			>> "$INITCFG"
	fi
fi
